#ifndef ENGINE_GAME_H
#define ENGINE_GAME_H

#define STARTUP_FILE_NAME	"rph_startup.cfg"

class MainData;
class rgTimer;
class rgSocket;
class GraphicsEngine;
class sk3DRomModel;
class ThingManager;

class GameEngine
{
public:
	GameEngine( MainData *p_mdata);
	~GameEngine();

	int load_startup_file( const char *fname);
	void process();

	long long game_clock() const { return m_game_clock;}
	long long game_clock_hz() const { return m_game_clock_hz;}

	void clear();

	int load_arena( const char *fname);
	int load_player_model( const char *fname);

	int create_thing_manager();
	ThingManager *thing_manager() { return m_thing_manager;}

private:
	MainData *mdata;

	// XXX: Networking
	rgSocket *m_console;

	// XXX: Timing
	double m_game_clock_tick;
	long long m_game_clock_hz;
	long long m_game_clock;
	rgTimer *m_game_timer;
	long long game_clocks_pending();


	// XXX: Graphics
	GraphicsEngine *gfx_engine;

	// XXX: 3D Models
	sk3DRomModel *m_player_model;

	// XXX: Things
	ThingManager *m_thing_manager;
};

#endif
